#!/usr/bin/env python
# -*- coding: utf-8 -*-

"""
file: postprocess.py
author: Nikolas Cruz-Camacho <cnc6@illinois.edu>
Purpose: Process and organize CMF++ output files into structured data formats.

This script is designed to handle the postprocessing of output files generated by the CMF++ (Chiral Mean Field) model.
It performs several key functions:
- Loads configuration data from a YAML file.
- Copies and organizes CMF++ output files into specified directories.
- Processes CMF++ output files to extract and export data in various formats, such as CSV and HDF5.
- Supports operations for different particle types, including quarks, baryons, and particle properties.
- Applies validation and formatting based on OpenAPI specifications.

The script supports flexible configuration through command-line arguments and configuration files, making it adaptable
to different user requirements and workflows.

Usage:
    python postprocess.py --validated_config_file_path <path_to_validated_config> --config_file_path <path_to_config> --root_output_path <path_to_output_folder>

Arguments:
    --validated_config_file_path: Path to the validated configuration file (optional, defaults to ../input/validated_config.yaml).
    --config_file_path: Path to the initial configuration file (optional, defaults to ../input/config.yaml).
    --root_output_path: Path to the root output folder where the CMF++ output files are stored (optional, defaults to ../output).

Example:
    python postprocess.py --validated_config_file_path ../input/validated_config.yaml --config_file_path ../input/config.yaml --root_output_path ../output
"""

import argparse
import os
import shutil
import yaml
import logging

from muses_porter import Porter

# Constants
BASE_DIR = os.path.dirname(__file__)
DEFAULT_CONFIG_FILE_PATH = os.path.join(BASE_DIR, "..", "input", "config.yaml")
DEFAULT_VALIDATED_CONFIG_FILE_PATH = os.path.join(
    BASE_DIR, "..", "input", "validated_config.yaml"
)
DEFAULT_ROOT_OUTPUT_PATH = os.path.join(BASE_DIR, "..", "output")
DEFAULT_API_SPECIFICATIONS_PATH = os.path.join(
    BASE_DIR, "..", "api", "OpenAPI_Specifications_CMF.yaml"
)

# Configure logging
logging.basicConfig(
    level=logging.INFO, format="%(asctime)s - %(levelname)s - %(message)s"
)


def load_configuration(config_file: str = DEFAULT_VALIDATED_CONFIG_FILE_PATH) -> dict:
    try:
        with open(config_file, "r") as file:
            return yaml.load(file, Loader=yaml.FullLoader)
    except FileNotFoundError:
        logging.error(f"Configuration file {config_file} not found.")
        raise
    except yaml.YAMLError as e:
        logging.error(f"Error parsing YAML file {config_file}: {e}")
        raise


def copy_file(src: str, dst: str) -> None:
    if not os.path.exists(src):
        logging.error(f"{src} file not found.")
        raise FileNotFoundError(f"{src} file not found.")
    shutil.copy(src, dst)
    logging.info(f"Copied file from {src} to {dst}")


def process_csv_to_output(
    yaml_input: dict,
    output_directory: str,
    output_directory_run: str,
    prefix_input: str,
    prefix_output: str,
    schema_input: str,
    schema_output: str,
) -> None:
    export_extension = "HDF5" if yaml_input.get("output_format") == "HDF5" else "CSV"
    logging.info(
        f"Processing CMF++ output from CMF_output_{prefix_input}.csv to CMF_output_{prefix_output}.{export_extension.lower()}"
    )

    file_path = os.path.join(output_directory_run, f"CMF_output_{prefix_input}.csv")
    if not os.path.exists(file_path):
        logging.error(f"{file_path} file not found.")
        raise FileNotFoundError(f"{file_path} file not found.")

    export_path = os.path.join(
        output_directory, f"CMF_output_{prefix_output}.{export_extension.lower()}"
    )
    export_path_run = os.path.join(
        output_directory_run, f"CMF_output_{prefix_output}.{export_extension.lower()}"
    )

    if (schema_input != schema_output) or (export_extension != "CSV"):
        porter = Porter()
        porter.import_table(
            file_path,
            extension="CSV",
            filename_schema=DEFAULT_API_SPECIFICATIONS_PATH,
            schema=schema_input,
            dropna=True,
            delimiter=",",
            verbose=False,
        )
        porter.export_table(
            export_path_run,
            filename_schema=DEFAULT_API_SPECIFICATIONS_PATH,
            schema=schema_output,
            extension=export_extension,
            dropna=True,
            delimiter="," if export_extension == "CSV" else None,
            verbose=False,
            float_format="%.12e" if export_extension == "CSV" else None,
        )
        porter.reset()

    copy_file(export_path_run, export_path)


def main() -> None:
    parser = argparse.ArgumentParser(description="Postprocess CMF++ output files.")
    parser.add_argument(
        "--validated_config_file_path",
        type=str,
        default=DEFAULT_VALIDATED_CONFIG_FILE_PATH,
        help="Path to the validated configuration file (optional)",
    )
    parser.add_argument(
        "--config_file_path",
        type=str,
        default=DEFAULT_CONFIG_FILE_PATH,
        help="Path to the configuration file (optional)",
    )
    parser.add_argument(
        "--root_output_path",
        type=str,
        default=DEFAULT_ROOT_OUTPUT_PATH,
        help="Path to the root output folder where the CMF_output files are stored",
    )

    args = parser.parse_args()
    yaml_input = load_configuration(args.validated_config_file_path)
    output_directory = args.root_output_path
    output_directory_run = os.path.join(output_directory, yaml_input["run_name"])

    logging.info(f"Running for folder: {output_directory_run}")
    os.makedirs(output_directory_run, exist_ok=True)

    try:
        copy_file(args.config_file_path, output_directory_run)
        if yaml_input.get("production_run", False):
            copy_file(args.config_file_path, output_directory)
            copy_file(args.validated_config_file_path, output_directory)

        process_csv_to_output(
            yaml_input,
            output_directory,
            output_directory_run,
            "stable",
            "stable",
            "CMF_output_all_EoS_variables",
            "CMF_output_all_EoS_variables",
        )
        process_csv_to_output(
            yaml_input,
            output_directory,
            output_directory_run,
            "metastable",
            "metastable",
            "CMF_output_all_EoS_variables",
            "CMF_output_all_EoS_variables",
        )
        process_csv_to_output(
            yaml_input,
            output_directory,
            output_directory_run,
            "unstable",
            "unstable",
            "CMF_output_all_EoS_variables",
            "CMF_output_all_EoS_variables",
        )

        if yaml_input.get("output_Lepton", False):
            logging.info("Processing CMF++ output for Lepton module...")
            process_csv_to_output(
                yaml_input,
                output_directory,
                output_directory_run,
                "quarks",
                "for_Lepton_quarks",
                "CMF_output_all_EoS_variables",
                "CMF_output_for_Lepton",
            )
            process_csv_to_output(
                yaml_input,
                output_directory,
                output_directory_run,
                "baryons",
                "for_Lepton_baryons",
                "CMF_output_all_EoS_variables",
                "CMF_output_for_Lepton",
            )

        if yaml_input.get("output_particle_properties", False):
            logging.info("Processing CMF++ output for Particle Properties...")
            process_csv_to_output(
                yaml_input,
                output_directory,
                output_directory_run,
                "particle_properties_quarks",
                "particle_properties_quarks",
                "CMF_output_particle_properties",
                "CMF_output_particle_properties",
            )
            process_csv_to_output(
                yaml_input,
                output_directory,
                output_directory_run,
                "particle_properties_baryons",
                "particle_properties_baryons",
                "CMF_output_particle_properties",
                "CMF_output_particle_properties",
            )

        if yaml_input.get("output_flavor_equilibration", False):
            logging.info("Processing CMF++ output for Flavor Equilibration module...")
            process_csv_to_output(
                yaml_input,
                output_directory,
                output_directory_run,
                "particle_properties_baryons",
                "for_Flavor_equilibration",
                "CMF_output_particle_properties",
                "CMF_output_for_Flavor_equilibration",
            )

        if yaml_input.get("production_run", False):
            shutil.rmtree(output_directory_run)

    except Exception as e:
        logging.error(f"An error occurred: {e}")
        raise


if __name__ == "__main__":
    logging.info(f"Starting execution of {__file__}...")
    main()
    logging.info(f"Execution end of {__file__}.")
